<?php

namespace Drupal\access_policy;

/**
 * Trait for toggling between storages.
 *
 * This is to ease the transition between storages.
 *
 * @deprecated in access_policy:1.0.0-beta1 and is removed from access_policy:1.0.0-beta2.
 *   There is no replacement.
 */
trait EntityAccessPolicyStorageTrait {

  /**
   * Get the entity access policy storage service.
   *
   * @return \Drupal\access_policy\EntityAccessPolicyStorageInterface
   *   The storage service
   */
  public function getEntityPolicyStorage() {
    return \Drupal::service('access_policy.storage.' . $this->getActiveStorageEngine());
  }

  /**
   * The current active storage engine.
   *
   * Older storage engines are no longer supported and are only maintained for
   * the sake of migration.
   *
   * @return string
   *   The storage engine.
   */
  private function getActiveStorageEngine() {
    return 'base_field';
  }

}
