<?php

namespace Drupal\access_policy\Plugin\views;

use Drupal\access_policy\EntityAccessPolicyStorageTrait;
use Drupal\views\Views;

/**
 * Assist views handler plugins to join to the access_policy entity.
 *
 * @internal
 */
trait AccessPolicyJoinViewsHandlerTrait {

  use EntityAccessPolicyStorageTrait;

  /**
   * {@inheritdoc}
   */
  public function ensureMyTable() {
    if (!isset($this->tableAlias)) {
      $table_alias = $this->query->ensureTable($this->table, $this->relationship);

      $left_entity_type = $this->entityTypeManager->getDefinition($this->getEntityType());
      $table_name = $this->getEntityPolicyStorage()->getTable($this->getEntityType());
      $configuration = [
        'table' => $table_name,
        'field' => $this->getEntityPolicyStorage()->getColumnName('entity_id'),
        'left_table' => $table_alias,
        'left_field' => $left_entity_type->getKey('id'),
      ];

      $join = Views::pluginManager('join')->createInstance('standard', $configuration);
      $this->tableAlias = $this->query->addRelationship($table_name, $join, $table_name);
    }

    return $this->tableAlias;
  }

}
